searchNodes=[{"ref":"Annex.html","title":"Annex","type":"module","doc":"Annex is a library for composing and running deep artificial"},{"ref":"Annex.html#activation/1","title":"Annex.activation/1","type":"function","doc":"Given an Activation&#39;s name returns appropriate Activation layer."},{"ref":"Annex.html#dense/2","title":"Annex.dense/2","type":"function","doc":"Given a number of rows and columns returns a Dense layer. Without the weights and biases of dense/4 this Dense layer will be have no neurons. Upon Layer.init_layer/2 the Dense layer will be initialized with random neurons; Neurons with random weights and biases."},{"ref":"Annex.html#dense/4","title":"Annex.dense/4","type":"function","doc":"Given a number of rows, columns, some weights, and some biases returns a built Dense layer."},{"ref":"Annex.html#dropout/1","title":"Annex.dropout/1","type":"function","doc":"Given a frequency (between 0.0 and 1.0) returns a LayerConfig for a Dropout. The Dropout layer randomly, at a given frequency, returns 0.0 for an input regardless of that input&#39;s value."},{"ref":"Annex.html#predict/2","title":"Annex.predict/2","type":"function","doc":"Given an initialized Learner learner and some data returns a prediction. The learner should be initialized with Learner.init_learner before being used with the predict/2 function. Also, it&#39;s a good idea to train the learner (using train/3 or train/4) before using it to make predicitons. Chances are slim that an untrained Learner is capable of making accurate predictions."},{"ref":"Annex.html#sequence/1","title":"Annex.sequence/1","type":"function","doc":"Given a list of layers returns a LayerConfig for a Sequence."},{"ref":"Annex.html#train/3","title":"Annex.train/3","type":"function","doc":"Trains an Annex.Learner given learner, data, labels, and options. The learner should be initialized Learner.init_learner/2 before being trained. Returns the trained learner along with some measure of loss or performance."},{"ref":"Annex.AnnexError.html","title":"Annex.AnnexError","type":"exception","doc":""},{"ref":"Annex.AnnexError.html#add_details/2","title":"Annex.AnnexError.add_details/2","type":"function","doc":""},{"ref":"Annex.AnnexError.html#build/2","title":"Annex.AnnexError.build/2","type":"function","doc":""},{"ref":"Annex.AnnexError.html#t:t/0","title":"Annex.AnnexError.t/0","type":"type","doc":""},{"ref":"Annex.Cost.html","title":"Annex.Cost","type":"behaviour","doc":"The Cost module defines the types, callbacks, and helper functions for calculating a the loss and gradient of the lossd, for gradient descent, of a network. The default Cost for Annex is Annex.Cost.MeanSquaredError."},{"ref":"Annex.Cost.html#c:calculate/1","title":"Annex.Cost.calculate/1","type":"callback","doc":""},{"ref":"Annex.Cost.html#calculate/2","title":"Annex.Cost.calculate/2","type":"function","doc":""},{"ref":"Annex.Cost.html#t:cost_function/0","title":"Annex.Cost.cost_function/0","type":"type","doc":""},{"ref":"Annex.Cost.html#t:t/0","title":"Annex.Cost.t/0","type":"type","doc":""},{"ref":"Annex.Cost.MeanSquaredError.html","title":"Annex.Cost.MeanSquaredError","type":"module","doc":"MeanSquaredError is the module that encapsulates the calculation of the mean squared error equation. The mean squared error is a calculation that describes the penalty (Cost) of the distance between points that highly penalizes large values and slightly penalizes small values by applying the square (x * x) of the difference between the expected values (labels) and the predicted values (predictions) of a sequence/network/model, summing the squares and taking the mean/average. MeanSquaredError is the default Cost for Annex. MeanSquaredError enables a neural network to more quickly &quot;learn&quot; by associating a higher error penalty for higher error values. Basically, the more incorrect a prediction the higher the penalty by a power of 2."},{"ref":"Annex.Cost.MeanSquaredError.html#calculate/1","title":"Annex.Cost.MeanSquaredError.calculate/1","type":"function","doc":"Callback implementation for Annex.Cost.calculate/1."},{"ref":"Annex.Data.html","title":"Annex.Data","type":"behaviour","doc":"Annex.Data defines the callbacks and helpers for data structures used by Annex. An implementer of the Annex.Layer behaviour must return an Annex.Data implementer from the c:data_type/0 callback."},{"ref":"Annex.Data.html#apply_op/3","title":"Annex.Data.apply_op/3","type":"function","doc":""},{"ref":"Annex.Data.html#c:apply_op/3","title":"Annex.Data.apply_op/3","type":"callback","doc":""},{"ref":"Annex.Data.html#apply_op/4","title":"Annex.Data.apply_op/4","type":"function","doc":""},{"ref":"Annex.Data.html#cast/2","title":"Annex.Data.cast/2","type":"function","doc":""},{"ref":"Annex.Data.html#c:cast/2","title":"Annex.Data.cast/2","type":"callback","doc":""},{"ref":"Annex.Data.html#cast/3","title":"Annex.Data.cast/3","type":"function","doc":"Annex.Data.cast/4 calls cast/3 for an Annex.Data behaviour implementing module. Valid shapes are a non-empty tuple of positive integers or any the atom :any. e.g. {2, 3} or {3, :any}"},{"ref":"Annex.Data.html#convert/3","title":"Annex.Data.convert/3","type":"function","doc":"Given a type, data, and a target_shape converts the data to the type and target_shape If the data matches the type and the data_shape matches the target_shape the data is returned unaltered. If either the type or target_shape do not match the data the data is casted using Data.cast/3."},{"ref":"Annex.Data.html#error/2","title":"Annex.Data.error/2","type":"function","doc":""},{"ref":"Annex.Data.html#flat_data_to_tensor/2","title":"Annex.Data.flat_data_to_tensor/2","type":"function","doc":""},{"ref":"Annex.Data.html#infer_type/1","title":"Annex.Data.infer_type/1","type":"function","doc":""},{"ref":"Annex.Data.html#is_flat_data/1","title":"Annex.Data.is_flat_data/1","type":"macro","doc":""},{"ref":"Annex.Data.html#c:is_type?/1","title":"Annex.Data.is_type?/1","type":"callback","doc":""},{"ref":"Annex.Data.html#is_type?/2","title":"Annex.Data.is_type?/2","type":"function","doc":"Given a type (Data implementing module) and some data returns true or false if the data is of the correct type. Calls is_type?/1 of the type."},{"ref":"Annex.Data.html#shape/1","title":"Annex.Data.shape/1","type":"function","doc":""},{"ref":"Annex.Data.html#c:shape/1","title":"Annex.Data.shape/1","type":"callback","doc":""},{"ref":"Annex.Data.html#shape/2","title":"Annex.Data.shape/2","type":"function","doc":"Given an Annex.Data type and the data returns the shape of the data. The shape of data is used to cast between the expected shapes from one Annex.Layer to the next or from one Annex.Sequence to the next."},{"ref":"Annex.Data.html#to_flat_list/1","title":"Annex.Data.to_flat_list/1","type":"function","doc":"Flattens an Annex.Data into a list of floats via Enum.into/2."},{"ref":"Annex.Data.html#c:to_flat_list/1","title":"Annex.Data.to_flat_list/1","type":"callback","doc":""},{"ref":"Annex.Data.html#to_flat_list/2","title":"Annex.Data.to_flat_list/2","type":"function","doc":"Flattens an Annex.Data into a list of floats via the type&#39;s callback."},{"ref":"Annex.Data.html#t:args/0","title":"Annex.Data.args/0","type":"type","doc":""},{"ref":"Annex.Data.html#t:data/0","title":"Annex.Data.data/0","type":"type","doc":""},{"ref":"Annex.Data.html#t:flat_data/0","title":"Annex.Data.flat_data/0","type":"type","doc":""},{"ref":"Annex.Data.html#t:op/0","title":"Annex.Data.op/0","type":"type","doc":""},{"ref":"Annex.Data.html#t:type/0","title":"Annex.Data.type/0","type":"type","doc":"A module that implements the Annex.Data Behaviour."},{"ref":"Annex.Data.DMatrix.html","title":"Annex.Data.DMatrix","type":"module","doc":"A 2D Matrix Annex.Data that uses the Tensor library as the underlying data structure. For the purpose of Dense Matrices it seems to be slower than a flat list or a list of lists."},{"ref":"Annex.Data.DMatrix.html#add/2","title":"Annex.Data.DMatrix.add/2","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#build/1","title":"Annex.Data.DMatrix.build/1","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#build/3","title":"Annex.Data.DMatrix.build/3","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#dot/2","title":"Annex.Data.DMatrix.dot/2","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#map/2","title":"Annex.Data.DMatrix.map/2","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#multiply/2","title":"Annex.Data.DMatrix.multiply/2","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#new_random/2","title":"Annex.Data.DMatrix.new_random/2","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#ones/2","title":"Annex.Data.DMatrix.ones/2","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#subtract/2","title":"Annex.Data.DMatrix.subtract/2","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#tensor/1","title":"Annex.Data.DMatrix.tensor/1","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#to_list_of_lists/1","title":"Annex.Data.DMatrix.to_list_of_lists/1","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#transpose/1","title":"Annex.Data.DMatrix.transpose/1","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#zeros/2","title":"Annex.Data.DMatrix.zeros/2","type":"function","doc":""},{"ref":"Annex.Data.DMatrix.html#t:columns/0","title":"Annex.Data.DMatrix.columns/0","type":"type","doc":""},{"ref":"Annex.Data.DMatrix.html#t:op/0","title":"Annex.Data.DMatrix.op/0","type":"type","doc":""},{"ref":"Annex.Data.DMatrix.html#t:rows/0","title":"Annex.Data.DMatrix.rows/0","type":"type","doc":""},{"ref":"Annex.Data.DMatrix.html#t:t/0","title":"Annex.Data.DMatrix.t/0","type":"type","doc":""},{"ref":"Annex.Data.DMatrix.html#t:tensor/0","title":"Annex.Data.DMatrix.tensor/0","type":"type","doc":""},{"ref":"Annex.Data.List1D.html","title":"Annex.Data.List1D","type":"module","doc":"The Annex.Data.List is the most basic Annex.Data."},{"ref":"Annex.Data.List1D.html#dot/2","title":"Annex.Data.List1D.dot/2","type":"function","doc":"Calculates the dot product which is the sum of element-wise multiplication of two enumerables."},{"ref":"Annex.Data.List1D.html#is_list1D/1","title":"Annex.Data.List1D.is_list1D/1","type":"macro","doc":""},{"ref":"Annex.Data.List1D.html#mean/1","title":"Annex.Data.List1D.mean/1","type":"function","doc":"Calculates the average of a 1D list."},{"ref":"Annex.Data.List1D.html#mean/2","title":"Annex.Data.List1D.mean/2","type":"function","doc":""},{"ref":"Annex.Data.List1D.html#new_random/1","title":"Annex.Data.List1D.new_random/1","type":"function","doc":"Generates a list of n floats between -1.0 and 1.0."},{"ref":"Annex.Data.List1D.html#normalize/1","title":"Annex.Data.List1D.normalize/1","type":"function","doc":"Turns a list of floats into floats between 0.0 and 1.0 at their respective ratio."},{"ref":"Annex.Data.List1D.html#ones/1","title":"Annex.Data.List1D.ones/1","type":"function","doc":""},{"ref":"Annex.Data.List1D.html#proportions/1","title":"Annex.Data.List1D.proportions/1","type":"function","doc":"Turns a list of floats into their proportions. The sum of the output should be approximately 1.0."},{"ref":"Annex.Data.List1D.html#subtract/2","title":"Annex.Data.List1D.subtract/2","type":"function","doc":""},{"ref":"Annex.Data.List1D.html#transpose/1","title":"Annex.Data.List1D.transpose/1","type":"function","doc":""},{"ref":"Annex.Data.List1D.html#t:t/0","title":"Annex.Data.List1D.t/0","type":"type","doc":""},{"ref":"Annex.Data.List2D.html","title":"Annex.Data.List2D","type":"module","doc":"List2D is a 2 dimensional list of lists of floats."},{"ref":"Annex.Data.List2D.html#cast/2","title":"Annex.Data.List2D.cast/2","type":"function","doc":"Given flat data and a valid 2-D shape (in the form of {rows, columns}) or a 2D list of lists of floats and a valid 2-D shapereturns a list of lists, a 2-D list of lists of floats."},{"ref":"Annex.Data.List2D.html#is_type?/1","title":"Annex.Data.List2D.is_type?/1","type":"function","doc":"Returns true for a list of lists of floats."},{"ref":"Annex.Data.List2D.html#map/2","title":"Annex.Data.List2D.map/2","type":"function","doc":""},{"ref":"Annex.Data.List2D.html#shape/1","title":"Annex.Data.List2D.shape/1","type":"function","doc":"The shape of a List2D can be calculated thus: rows is the number of elements in the outermost list. columns is the count of the elements of the first row."},{"ref":"Annex.Data.List2D.html#to_flat_list/1","title":"Annex.Data.List2D.to_flat_list/1","type":"function","doc":"The shape of a List2D can be calculated thus: rows is the number of elements in the outermost list. columns is the count of the elements of the first row."},{"ref":"Annex.Data.List2D.html#transpose/1","title":"Annex.Data.List2D.transpose/1","type":"function","doc":""},{"ref":"Annex.Data.List2D.html#t:t/0","title":"Annex.Data.List2D.t/0","type":"type","doc":""},{"ref":"Annex.Dataset.html","title":"Annex.Dataset","type":"module","doc":"A"},{"ref":"Annex.Dataset.html#randomize/1","title":"Annex.Dataset.randomize/1","type":"function","doc":""},{"ref":"Annex.Dataset.html#split/2","title":"Annex.Dataset.split/2","type":"function","doc":"Random unifmormly splits a given dataset into two datasets at a given frequency. Very useful for splitting traiings"},{"ref":"Annex.Dataset.html#zip/2","title":"Annex.Dataset.zip/2","type":"function","doc":""},{"ref":"Annex.Dataset.html#t:inputs/0","title":"Annex.Dataset.inputs/0","type":"type","doc":""},{"ref":"Annex.Dataset.html#t:labels/0","title":"Annex.Dataset.labels/0","type":"type","doc":""},{"ref":"Annex.Dataset.html#t:row/0","title":"Annex.Dataset.row/0","type":"type","doc":""},{"ref":"Annex.Dataset.html#t:t/0","title":"Annex.Dataset.t/0","type":"type","doc":""},{"ref":"Annex.Debug.html","title":"Annex.Debug","type":"module","doc":"A module for running checks and getting helpful messages."},{"ref":"Annex.Debug.html#debug/1","title":"Annex.Debug.debug/1","type":"macro","doc":""},{"ref":"Annex.Debug.html#debug_assert/2","title":"Annex.Debug.debug_assert/2","type":"macro","doc":""},{"ref":"Annex.Debug.html#format_variables/1","title":"Annex.Debug.format_variables/1","type":"function","doc":""},{"ref":"Annex.Defaults.html","title":"Annex.Defaults","type":"module","doc":"Defaults handles the access to compile-time configuration values for default values of Annex."},{"ref":"Annex.Defaults.html#cost/0","title":"Annex.Defaults.cost/0","type":"function","doc":""},{"ref":"Annex.Defaults.html#get_defaults/0","title":"Annex.Defaults.get_defaults/0","type":"function","doc":""},{"ref":"Annex.Defaults.html#get_defaults/2","title":"Annex.Defaults.get_defaults/2","type":"function","doc":""},{"ref":"Annex.Defaults.html#learning_rate/0","title":"Annex.Defaults.learning_rate/0","type":"function","doc":""},{"ref":"Annex.Examples.Iris.html","title":"Annex.Examples.Iris","type":"module","doc":""},{"ref":"Annex.Examples.Iris.html#cast/1","title":"Annex.Examples.Iris.cast/1","type":"function","doc":""},{"ref":"Annex.Examples.Iris.html#line_to_map/1","title":"Annex.Examples.Iris.line_to_map/1","type":"function","doc":""},{"ref":"Annex.Examples.Iris.html#load/0","title":"Annex.Examples.Iris.load/0","type":"function","doc":""},{"ref":"Annex.Examples.Iris.html#normalize_by_name/2","title":"Annex.Examples.Iris.normalize_by_name/2","type":"function","doc":""},{"ref":"Annex.Examples.Iris.html#prep_data/1","title":"Annex.Examples.Iris.prep_data/1","type":"function","doc":""},{"ref":"Annex.Examples.Iris.html#prep_row/1","title":"Annex.Examples.Iris.prep_row/1","type":"function","doc":""},{"ref":"Annex.Examples.Iris.html#run/0","title":"Annex.Examples.Iris.run/0","type":"function","doc":""},{"ref":"Annex.Examples.Iris.html#species_to_label/1","title":"Annex.Examples.Iris.species_to_label/1","type":"function","doc":""},{"ref":"Annex.Layer.html","title":"Annex.Layer","type":"behaviour","doc":"The Annex.Layer is the module that defines types, callbacks, and helper for Layers. By implementing the Layer behaviour a struct/model can be used along side other Layers to compose the layers of a deep neural network."},{"ref":"Annex.Layer.html#backprop/3","title":"Annex.Layer.backprop/3","type":"function","doc":""},{"ref":"Annex.Layer.html#c:backprop/3","title":"Annex.Layer.backprop/3","type":"callback","doc":""},{"ref":"Annex.Layer.html#backward_shape/1","title":"Annex.Layer.backward_shape/1","type":"function","doc":""},{"ref":"Annex.Layer.html#convert/3","title":"Annex.Layer.convert/3","type":"function","doc":""},{"ref":"Annex.Layer.html#data_type/1","title":"Annex.Layer.data_type/1","type":"function","doc":""},{"ref":"Annex.Layer.html#c:data_type/1","title":"Annex.Layer.data_type/1","type":"callback","doc":""},{"ref":"Annex.Layer.html#feedforward/2","title":"Annex.Layer.feedforward/2","type":"function","doc":""},{"ref":"Annex.Layer.html#c:feedforward/2","title":"Annex.Layer.feedforward/2","type":"callback","doc":""},{"ref":"Annex.Layer.html#forward_shape/1","title":"Annex.Layer.forward_shape/1","type":"function","doc":""},{"ref":"Annex.Layer.html#has_data_type?/1","title":"Annex.Layer.has_data_type?/1","type":"function","doc":""},{"ref":"Annex.Layer.html#has_shapes?/1","title":"Annex.Layer.has_shapes?/1","type":"function","doc":""},{"ref":"Annex.Layer.html#init_layer/1","title":"Annex.Layer.init_layer/1","type":"function","doc":""},{"ref":"Annex.Layer.html#c:init_layer/1","title":"Annex.Layer.init_layer/1","type":"callback","doc":""},{"ref":"Annex.Layer.html#input_shape/1","title":"Annex.Layer.input_shape/1","type":"function","doc":""},{"ref":"Annex.Layer.html#is_layer?/1","title":"Annex.Layer.is_layer?/1","type":"function","doc":""},{"ref":"Annex.Layer.html#output_shape/1","title":"Annex.Layer.output_shape/1","type":"function","doc":""},{"ref":"Annex.Layer.html#shapes/1","title":"Annex.Layer.shapes/1","type":"function","doc":""},{"ref":"Annex.Layer.html#c:shapes/1","title":"Annex.Layer.shapes/1","type":"callback","doc":""},{"ref":"Annex.Layer.html#t:t/0","title":"Annex.Layer.t/0","type":"type","doc":""},{"ref":"Annex.Layer.Activation.html","title":"Annex.Layer.Activation","type":"module","doc":"The Activation layer is the Annex.Layer that is responsible for applying an activation function to the data during the feedforward and supplying the gradient function (derivative) of the activation function to the Backprops during backpropagation."},{"ref":"Annex.Layer.Activation.html#from_name/1","title":"Annex.Layer.Activation.from_name/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#generate_outputs/2","title":"Annex.Layer.Activation.generate_outputs/2","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#get_activator/1","title":"Annex.Layer.Activation.get_activator/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#get_derivative/1","title":"Annex.Layer.Activation.get_derivative/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#get_inputs/1","title":"Annex.Layer.Activation.get_inputs/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#get_name/1","title":"Annex.Layer.Activation.get_name/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#relu/1","title":"Annex.Layer.Activation.relu/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#relu_deriv/1","title":"Annex.Layer.Activation.relu_deriv/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#relu_deriv/2","title":"Annex.Layer.Activation.relu_deriv/2","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#sigmoid/1","title":"Annex.Layer.Activation.sigmoid/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#sigmoid_deriv/1","title":"Annex.Layer.Activation.sigmoid_deriv/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#softmax/1","title":"Annex.Layer.Activation.softmax/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#tanh/1","title":"Annex.Layer.Activation.tanh/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#tanh_deriv/1","title":"Annex.Layer.Activation.tanh_deriv/1","type":"function","doc":""},{"ref":"Annex.Layer.Activation.html#t:data/0","title":"Annex.Layer.Activation.data/0","type":"type","doc":""},{"ref":"Annex.Layer.Activation.html#t:func_name/0","title":"Annex.Layer.Activation.func_name/0","type":"type","doc":""},{"ref":"Annex.Layer.Activation.html#t:func_type/0","title":"Annex.Layer.Activation.func_type/0","type":"type","doc":""},{"ref":"Annex.Layer.Activation.html#t:t/0","title":"Annex.Layer.Activation.t/0","type":"type","doc":""},{"ref":"Annex.Layer.Backprop.html","title":"Annex.Layer.Backprop","type":"module","doc":"Backprop is a module that contains helper functions for manipulating the Keyword list that is passed up through a Sequence during the backprop phase. The Backprop module is not a Layer implementing module."},{"ref":"Annex.Layer.Backprop.html#defaults/0","title":"Annex.Layer.Backprop.defaults/0","type":"function","doc":""},{"ref":"Annex.Layer.Backprop.html#get_derivative/1","title":"Annex.Layer.Backprop.get_derivative/1","type":"function","doc":""},{"ref":"Annex.Layer.Backprop.html#get_learning_rate/1","title":"Annex.Layer.Backprop.get_learning_rate/1","type":"function","doc":""},{"ref":"Annex.Layer.Backprop.html#new/1","title":"Annex.Layer.Backprop.new/1","type":"function","doc":""},{"ref":"Annex.Layer.Backprop.html#put_derivative/2","title":"Annex.Layer.Backprop.put_derivative/2","type":"function","doc":""},{"ref":"Annex.Layer.Backprop.html#t:cost_func/0","title":"Annex.Layer.Backprop.cost_func/0","type":"type","doc":""},{"ref":"Annex.Layer.Backprop.html#t:derivative/0","title":"Annex.Layer.Backprop.derivative/0","type":"type","doc":""},{"ref":"Annex.Layer.Backprop.html#t:t/0","title":"Annex.Layer.Backprop.t/0","type":"type","doc":""},{"ref":"Annex.Layer.Dense.html","title":"Annex.Layer.Dense","type":"module","doc":"rows are the number outputs and columns are the number of inputs."},{"ref":"Annex.Layer.Dense.html#columns/1","title":"Annex.Layer.Dense.columns/1","type":"function","doc":""},{"ref":"Annex.Layer.Dense.html#rows/1","title":"Annex.Layer.Dense.rows/1","type":"function","doc":""},{"ref":"Annex.Layer.Dense.html#t:data/0","title":"Annex.Layer.Dense.data/0","type":"type","doc":""},{"ref":"Annex.Layer.Dense.html#t:t/0","title":"Annex.Layer.Dense.t/0","type":"type","doc":""},{"ref":"Annex.Layer.Dropout.html","title":"Annex.Layer.Dropout","type":"module","doc":"Given a frequency the dropout layer randomly drops an input at the frequency."},{"ref":"Annex.Layer.Dropout.html#frequency/1","title":"Annex.Layer.Dropout.frequency/1","type":"function","doc":""},{"ref":"Annex.Layer.Dropout.html#is_frequency/1","title":"Annex.Layer.Dropout.is_frequency/1","type":"macro","doc":""},{"ref":"Annex.Layer.Dropout.html#t:data/0","title":"Annex.Layer.Dropout.data/0","type":"type","doc":""},{"ref":"Annex.Layer.Dropout.html#t:t/0","title":"Annex.Layer.Dropout.t/0","type":"type","doc":""},{"ref":"Annex.Layer.Sequence.html","title":"Annex.Layer.Sequence","type":"module","doc":"The Sequence layer is the container and orchestrator of other layers and is used to define a list of Layers that compose a deep neural network."},{"ref":"Annex.Layer.Sequence.html#get_layers/1","title":"Annex.Layer.Sequence.get_layers/1","type":"function","doc":""},{"ref":"Annex.Layer.Sequence.html#t:layers/0","title":"Annex.Layer.Sequence.layers/0","type":"type","doc":""},{"ref":"Annex.Layer.Sequence.html#t:t/0","title":"Annex.Layer.Sequence.t/0","type":"type","doc":""},{"ref":"Annex.LayerConfig.html","title":"Annex.LayerConfig","type":"module","doc":"The Annex.LayerConfig is the intermediate structure used to intialize an Annex.Layer. This is particularly useful for building the same Layer given many different combinations of configuration."},{"ref":"Annex.LayerConfig.html#add/2","title":"Annex.LayerConfig.add/2","type":"function","doc":""},{"ref":"Annex.LayerConfig.html#add/3","title":"Annex.LayerConfig.add/3","type":"function","doc":""},{"ref":"Annex.LayerConfig.html#build/2","title":"Annex.LayerConfig.build/2","type":"function","doc":""},{"ref":"Annex.LayerConfig.html#details/1","title":"Annex.LayerConfig.details/1","type":"function","doc":""},{"ref":"Annex.LayerConfig.html#fetch/2","title":"Annex.LayerConfig.fetch/2","type":"function","doc":""},{"ref":"Annex.LayerConfig.html#fetch_lazy/3","title":"Annex.LayerConfig.fetch_lazy/3","type":"function","doc":""},{"ref":"Annex.LayerConfig.html#init_layer/1","title":"Annex.LayerConfig.init_layer/1","type":"function","doc":""},{"ref":"Annex.LayerConfig.html#module/1","title":"Annex.LayerConfig.module/1","type":"function","doc":""},{"ref":"Annex.LayerConfig.html#t:details/0","title":"Annex.LayerConfig.details/0","type":"type","doc":""},{"ref":"Annex.LayerConfig.html#t:t/1","title":"Annex.LayerConfig.t/1","type":"type","doc":""},{"ref":"Annex.Learner.html","title":"Annex.Learner","type":"behaviour","doc":"The Learner module defines the types, callbacks, and helper functions for a Learner. A Learner is a model that is capable of supervised learning."},{"ref":"Annex.Learner.html#has_train?/1","title":"Annex.Learner.has_train?/1","type":"function","doc":""},{"ref":"Annex.Learner.html#init_learner/2","title":"Annex.Learner.init_learner/2","type":"function","doc":""},{"ref":"Annex.Learner.html#c:init_learner/2","title":"Annex.Learner.init_learner/2","type":"callback","doc":""},{"ref":"Annex.Learner.html#is_learner?/1","title":"Annex.Learner.is_learner?/1","type":"function","doc":""},{"ref":"Annex.Learner.html#predict/2","title":"Annex.Learner.predict/2","type":"function","doc":""},{"ref":"Annex.Learner.html#c:predict/2","title":"Annex.Learner.predict/2","type":"callback","doc":""},{"ref":"Annex.Learner.html#train/3","title":"Annex.Learner.train/3","type":"function","doc":""},{"ref":"Annex.Learner.html#c:train/3","title":"Annex.Learner.train/3","type":"callback","doc":""},{"ref":"Annex.Learner.html#t:data/0","title":"Annex.Learner.data/0","type":"type","doc":""},{"ref":"Annex.Learner.html#t:options/0","title":"Annex.Learner.options/0","type":"type","doc":""},{"ref":"Annex.Learner.html#t:t/0","title":"Annex.Learner.t/0","type":"type","doc":""},{"ref":"Annex.Learner.html#t:training_output/0","title":"Annex.Learner.training_output/0","type":"type","doc":""},{"ref":"Annex.Optimizer.html","title":"Annex.Optimizer","type":"behaviour","doc":"The Optimizer Behaviour and context for calling optimizer implementations."},{"ref":"Annex.Optimizer.html#c:train/3","title":"Annex.Optimizer.train/3","type":"callback","doc":""},{"ref":"Annex.Optimizer.html#train/4","title":"Annex.Optimizer.train/4","type":"function","doc":""},{"ref":"Annex.Optimizer.html#t:t/0","title":"Annex.Optimizer.t/0","type":"type","doc":""},{"ref":"Annex.Optimizer.SGD.html","title":"Annex.Optimizer.SGD","type":"module","doc":"The optimizer for mini-batch (or non-batching) stochastic gradient descent."},{"ref":"Annex.Optimizer.SGD.html#batch_dataset/2","title":"Annex.Optimizer.SGD.batch_dataset/2","type":"function","doc":""},{"ref":"Annex.Perceptron.html","title":"Annex.Perceptron","type":"module","doc":"A simple perceptron Learner capable of making good predictions given a linearly separable dataset and labels."},{"ref":"Annex.Perceptron.html#new/3","title":"Annex.Perceptron.new/3","type":"function","doc":""},{"ref":"Annex.Perceptron.html#predict/2","title":"Annex.Perceptron.predict/2","type":"function","doc":""},{"ref":"Annex.Perceptron.html#train/3","title":"Annex.Perceptron.train/3","type":"function","doc":""},{"ref":"Annex.Perceptron.html#t:activation/0","title":"Annex.Perceptron.activation/0","type":"type","doc":""},{"ref":"Annex.Perceptron.html#t:data_type/0","title":"Annex.Perceptron.data_type/0","type":"type","doc":""},{"ref":"Annex.Perceptron.html#t:t/0","title":"Annex.Perceptron.t/0","type":"type","doc":""},{"ref":"Annex.Shape.html","title":"Annex.Shape","type":"module","doc":"The Shape module encapsulates helper functions for use in determining the shapes and validity of shapes between Layers and Layers; Data and Data; and Data and Layers."},{"ref":"Annex.Shape.html#convert_abstract_to_concrete/2","title":"Annex.Shape.convert_abstract_to_concrete/2","type":"function","doc":""},{"ref":"Annex.Shape.html#factor/1","title":"Annex.Shape.factor/1","type":"function","doc":""},{"ref":"Annex.Shape.html#is_factor_of?/2","title":"Annex.Shape.is_factor_of?/2","type":"function","doc":""},{"ref":"Annex.Shape.html#is_shape/1","title":"Annex.Shape.is_shape/1","type":"macro","doc":""},{"ref":"Annex.Shape.html#is_shape?/1","title":"Annex.Shape.is_shape?/1","type":"function","doc":""},{"ref":"Annex.Shape.html#is_shape_value?/1","title":"Annex.Shape.is_shape_value?/1","type":"function","doc":""},{"ref":"Annex.Shape.html#kind/1","title":"Annex.Shape.kind/1","type":"function","doc":"Given a valid shape checks the content of the shape to determine whether the shape is a :concrete kind or an :abstract kind of shape. A :concrete shape contains only positive integers and represents a known, exact shape. For example, the shape [3, 4] represents a two dimensional matrix that has 3 rows and 4 columns. Data always has a :concrete shape; the elements of a Data can be counted. An :abstract shape contains both positive integers and/or :any. An :abstract shape represents a partially unknown shape. For example, the shape [3, :any] represents a two dimensional shape that has 3 rows and any positive integer n number of columns. Some operations on Data can express shape requirements in an :abstract way. The :abstract shape idea is particularly useful for describing the possible valid shapes for casting data for a shaped Layer. For example, during feedfoward a Dense layer requires that input has the same number of rows as the Dense layer has columns so that it can perform a matrix dot operation. For a Dense layer with 2 rows and 3 columns the shape it demands for casting would be [3, :any]."},{"ref":"Annex.Shape.html#product/1","title":"Annex.Shape.product/1","type":"function","doc":"Returns the product of a concrete shape. Given an abstract shape product/1 will raise an ArithmeticError. The closest related function to product/1 is factor/1. If you need the product of the integers without the :any in the shape use factor/2. For more info about concrete vs abstract shapes see Shape.kind/1."},{"ref":"Annex.Shape.html#resolve_columns/1","title":"Annex.Shape.resolve_columns/1","type":"function","doc":""},{"ref":"Annex.Shape.html#resolve_rows/1","title":"Annex.Shape.resolve_rows/1","type":"function","doc":""},{"ref":"Annex.Shape.html#t:abstract/0","title":"Annex.Shape.abstract/0","type":"type","doc":""},{"ref":"Annex.Shape.html#t:abstract_dimension/0","title":"Annex.Shape.abstract_dimension/0","type":"type","doc":""},{"ref":"Annex.Shape.html#t:concrete/0","title":"Annex.Shape.concrete/0","type":"type","doc":""},{"ref":"Annex.Shape.html#t:concrete_dimension/0","title":"Annex.Shape.concrete_dimension/0","type":"type","doc":""},{"ref":"Annex.Shape.html#t:shape_any/0","title":"Annex.Shape.shape_any/0","type":"type","doc":""},{"ref":"Annex.Shape.html#t:t/0","title":"Annex.Shape.t/0","type":"type","doc":""},{"ref":"Annex.Utils.html","title":"Annex.Utils","type":"module","doc":"This module holds functions that are not necessarily specific to one of Annex&#39;s other modules."},{"ref":"Annex.Utils.html#is_module?/1","title":"Annex.Utils.is_module?/1","type":"function","doc":""},{"ref":"Annex.Utils.html#is_pos_integer/1","title":"Annex.Utils.is_pos_integer/1","type":"macro","doc":""},{"ref":"Annex.Utils.html#random_float/0","title":"Annex.Utils.random_float/0","type":"function","doc":"Generates a float between -1.0 and 1.0"},{"ref":"Annex.Utils.html#validate/3","title":"Annex.Utils.validate/3","type":"macro","doc":""},{"ref":"Annex.Utils.html#zip/2","title":"Annex.Utils.zip/2","type":"function","doc":"A strict zip function in which the two given enumerables must be the same size."},{"ref":"Annex.Utils.html#zipmap/3","title":"Annex.Utils.zipmap/3","type":"function","doc":"A strict zip-while-mapping function in which the two given enumerables must be the same size."},{"ref":"IrisParser.html","title":"IrisParser","type":"module","doc":""},{"ref":"IrisParser.html#dump_to_iodata/1","title":"IrisParser.dump_to_iodata/1","type":"function","doc":"Eagerly dumps an enumerable into iodata (a list of binaries and bytes and other lists). Callback implementation for NimbleCSV.dump_to_iodata/1."},{"ref":"IrisParser.html#dump_to_stream/1","title":"IrisParser.dump_to_stream/1","type":"function","doc":"Lazily dumps from an enumerable to a stream. It returns a stream that emits each row as iodata. Callback implementation for NimbleCSV.dump_to_stream/1."},{"ref":"IrisParser.html#parse_enumerable/2","title":"IrisParser.parse_enumerable/2","type":"function","doc":"Eagerly parses CSV from an enumerable and returns a list of rows. Options :skip_headers - when true, skips headers. Defaults to true. Set it to false to keep headers or when the CSV has no headers. Callback implementation for NimbleCSV.parse_enumerable/2."},{"ref":"IrisParser.html#parse_stream/2","title":"IrisParser.parse_stream/2","type":"function","doc":"Lazily parses CSV from a stream and returns a stream of rows. Options :skip_headers - when true, skips headers. Defaults to true. Set it to false to keep headers or when the CSV has no headers. Callback implementation for NimbleCSV.parse_stream/2."},{"ref":"IrisParser.html#parse_string/2","title":"IrisParser.parse_string/2","type":"function","doc":"Eagerly parses CSV from a string and returns a list of rows. Options :skip_headers - when true, skips headers. Defaults to true. Set it to false to keep headers or when the CSV has no headers. Callback implementation for NimbleCSV.parse_string/2."}]